
(* This file was auto-generated based on "error_messages.txt". *)

(* Please note that the function [message] can raise [Not_found]. *)

let message =
  fun s ->
    match s with
    | 60 | 78 | 90 | 92 ->
        "Anonymous predicate declaration expected.\nExamples:\n(pred i:ty, o:ty)\n(pred)\n"
    | 531 ->
        "You cannot ascribe a type on the head predicate.\n"
    | 297 | 296 | 138 | 139 | 140 | 141 | 211 | 303 | 304 | 59 ->
        "Illformed type cast.\nExamples:\n(x : ty)\npi x : ty \\ t\nlam (x : ty \\ t)\n"
    | 3 | 57 | 97 | 98 | 101 | 105 | 108 | 109 | 113 | 114 | 490 | 491 | 518 | 519 ->
        "Illformed pi or sigma.\nExamples:\npi X\\ p X\npi X Y Z\\ p X, q Y Z\nsigma X\\ p X\nsigma X Y Z\\ p X, q Y Z\n"
    | 478 | 413 | 414 | 416 ->
        "Mixfix declaration expected (Teyjus compatibility, ignored by Elpi).\nExamples:\ninfixl and 30.\ninfixr ++ 45.\nprefix - 12.\n"
    | 355 | 356 ->
        "Useonly directive expected (Teyjus compatibility, ignored by Elpi).\nExamples:\nuseonly foo.\nuseonly foo, bar.\n"
    | 359 | 461 ->
        "Closed directive expected (Teyjus compatibility, ignored by Elpi).\nExamples:\nclosed foo.\nclosed foo, bar.\n"
    | 398 ->
        "Local kind declaration expected (Teyjus compatibility, ignored by Elpi).\nExamples:\nlocalkind foo.\nlocalkind foo, bar.\n"
    | 369 | 392 | 476 ->
        "Module/Signature header expected (Teyjus compatibility, ignored by Elpi).\nExamples:\nmodule foo.\nsig bar.\n"
    | 420 | 419 ->
        "Definition export directive expected (Teyjus compatibility, ignored by Elpi).\nExamples:\nexportdef foo, bar.\nexportdef foo  (term -> term).\n"
    | 515 | 516 | 87 | 61 | 470 | 85 | 73 | 74 | 524 | 525 | 526 | 527 | 70 | 68 | 71 ->
        "Predicate declaration expected. Examples:\npred append i:list A, i:list A, o:list A.\npred append i:list A i:list A o:list A.\npred mapR i:list A, i:(pred i:A, o:B), o:list B.\nfunc map list A, (func A -> B) -> list B.\n"
    | 486 ->
        "External declaration expected. Examples:\nexternal type foo term -> prop.\nexternal pred foo i:term.\n"
    | 423 | 428 | 425 | 426 ->
        "Constraint Handling Rule header expected. Examples:\nconstraint foo {\nconstraint foo bar {\n"
    | 406 | 358 | 408 | 409 | 407 ->
        "Kind declaration expected. Examples:\nkind term  type.\nkind list  type -> type.\n"
    | 400 | 401 | 403 ->
        "Local symbol declaration expected. Examples:\nlocal foo.\nlocal foo, bar.\nlocal foo (term -> term).\n"
    | 389 | 390 ->
        "Namespace header expected. Examples:\nnamespace foo {\n"
    | 371 | 373 | 375 | 376 | 377 | 378 | 379 | 381 | 382 | 383 ->
        "Shortening directive expected. Examples:\nshorten foo.{ bar }.\nshorten foo.{ bar , baz }.\nshorten foo.{ bar , baz. { qux , dim } }.\n"
    | 361 | 362 | 102 | 367 | 465 | 363 | 364 ->
        "Type abbreviation expected. Examples:\ntypeabbrev context (list term).\ntypeabbrev (two A) (pair A A).\n"
    | 123 | 112 | 283 | 274 | 210 | 216 ->
        "List expected. Examples:\n[ this , that | More ].\n[ Head | Tail ].\n"
    | 601 | 606 | 8 | 605 ->
        "Malformed accumulate. Examples:\naccumulate foo.\naccumulate foo, bar.\naccumulate \"foo/bar\".\n"
    | 494 | 493 | 484 | 500 | 504 | 505 | 509 | 510 | 512 | 497 | 498 | 495 ->
        "Malformed CHR rule declaration. Examples:\nrule (match this).\nrule (match this) \\ (remove that).\nrule (match this) \\ (remove that) | (only when).\nrule (match this) \\ (remove that) | (only when) <=> (add this).\nrule (E :> Ctx ?- match this goal).\n"
    | 487 | 488 | 467 ->
        "Malformed type declaration. Examples:\ntype app tm -> tm -> tm.\ntype lam (tm -> tm) -> tm.\ntype (++) list A -> list A -> list A.\n"
    | 458 | 459 ->
        "Malformed 'external' attribute. Example:\n:external pred\n"
    | 453 | 455 | 435 ->
        "Malformed grafting attribute. Example:\n:before \"some name\"\n:after \"some other name\"\n:replace \"some other name\"\n:remove \"some other name\"\n"
    | 449 ->
        "Malformed 'if' attribute. Example:\n:if \"VARIABLE\"\n"
    | 439 | 440 | 447 ->
        "Malformed 'index' attribute. Example:\n:index(1 _ 1)\n"
    | 437 ->
        "Malformed 'name' attribute. Example:\n:name \"name of the clause\"\n"
    | 431 | 433 | 444 ->
        "Attribute expected. Examples:\n:name \"some name\"\n:index (_ 1 1)\n"
    | 394 | 395 | 396 | 397 ->
        "Malformed macro declaration. Example:\nmacro @foo X Y :- p X => q Y.\n"
    | 350 ->
        "Prefix symbol expected.\n"
    | 347 ->
        "Postifx symbol expected.\n"
    | 314 ->
        "Infix symbol expected.\n"
    | 46 ->
        "Right parenthesis ')' expected.\n"
    | 0 | 106 | 107 ->
        "Term expected.\n"
    | 43 ->
        "Malformed as binding. Examples:\n(f X as Y)\n([_,_|_] as Y)\n"
    | 293 ->
        "Mixfix symbol or term expected.\n"
    | 535 | 537 | 557 | 559 | 539 | 561 | 564 | 566 | 568 | 570 | 572 | 574 | 576 | 578 | 580 | 541 | 543 | 545 | 555 | 584 | 586 | 590 | 592 | 596 | 598 | 521 | 522 | 221 | 243 | 225 | 255 | 223 | 229 | 239 | 245 | 257 | 227 | 231 | 259 | 263 | 235 | 261 | 265 | 233 | 237 | 253 | 269 | 219 | 291 | 126 | 300 | 310 | 205 | 161 | 177 | 185 | 189 | 157 | 169 | 181 | 151 | 155 | 183 | 187 | 159 | 119 | 122 | 143 | 167 | 147 | 129 | 137 | 135 | 179 | 145 | 153 | 207 | 163 | 193 | 197 | 201 | 203 | 273 | 277 | 280 | 284 | 530 | 294 | 302 | 523 | 165 | 171 | 173 | 175 | 191 | 241 | 247 | 249 | 251 | 267 | 275 | 547 | 549 | 551 | 553 | 582 | 199 | 594 | 308 | 306 | 95 | 99 | 214 | 94 | 532 | 58 | 281 | 124 | 208 | 212 | 213 | 195 | 271 | 588 | 206 | 100 | 63 | 66 | 67 | 76 | 82 ->
        "Term expected, got keyword.\n"
    | 534 ->
        "Unexpected keyword.\n"
    | 353 | 480 ->
        "Unexpected start of program clause or declaration.\n"
    | 166 | 154 | 186 | 182 | 158 | 188 | 156 | 152 | 146 | 178 | 144 | 176 | 554 | 563 | 556 | 242 | 558 | 538 | 560 | 565 | 567 | 569 | 571 | 573 | 575 | 577 | 579 | 232 | 264 | 234 | 262 | 258 | 230 | 226 | 256 | 228 | 222 | 254 | 224 | 150 | 180 | 589 | 540 | 542 | 544 | 583 | 585 | 591 | 595 | 597 | 536 | 260 | 244 | 238 | 142 | 162 | 168 | 184 | 160 | 192 | 196 | 200 | 202 | 204 | 220 | 236 | 252 | 268 | 272 | 276 | 279 | 299 | 286 | 215 | 164 | 170 | 172 | 174 | 190 | 240 | 246 | 248 | 250 | 266 | 546 | 548 | 550 | 552 | 581 | 198 | 593 | 194 | 270 | 587 | 64 ->
        "This infix operator expects a right hand side.\n"
    | 125 | 529 | 118 ->
        "This prefix operator expects an argument.\n"
    | _ ->
        raise Not_found
