
module Make
           ( C : Parser_config.ParseFile )
: sig
  
  (* The type of tokens. *)
  
  type token = Elpi_lexer_config.Tokens.token
  
  (* This exception is raised by the monolithic API functions. *)
  
  exception Error of int
  
  (* The monolithic API. *)
  
  val program: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.Program.t)
  
  val prefix_SYMB: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.Func.t)
  
  val postfix_SYMB: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.Func.t)
  
  val infix_SYMB: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.Func.t)
  
  val goal: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.Term.t)
  
end
